
//-------------------------------------------------<                   axlib v1.1                    >----------------------------------------------------
//-------------------------------------------------<            1wire       >----------------------------------------------------
//-------------------------------------------------<      2015 http://www.avrki.ru    >----------------------------------------------------

#ifndef W_H_
#define W_H_

#if !defined(MAIN_INIT_H_)
#error "You must included (#include \"main_init.h\") befor use (#include <axlib/1w.h>)."
#endif

//-------------------------------------------------------------------------
//						  
//-------------------------------------------------------------------------
#define PORT_W		B
#define A	0
#define B	1
#define C	2
#define D	3

#ifdef	PORTA
	#if PORT_W == A
	#define PORT PORTA
	#define PIN PINA
	#define DDR DDRA
	#endif
#endif

#ifdef	PORTB
	#if PORT_W == B
	#define PORT PORTB
	#define PIN PINB
	#define DDR DDRB
	#endif
#endif

#ifdef	PORTC
	#if PORT_W == C
	#define PORT PORTC
	#define PIN PINC
	#define DDR DDRC
	#endif
#endif

#ifdef	PORTD
	#if PORT_W == D
	#define PORT PORTD
	#define PIN PIND
	#define DDR DDRD
	#endif
#endif

#define PIN_W		1
#define OWIRE_0 DDR |= (1<<PIN_W)
#define OWIRE_1 DDR &= ~(1<<PIN_W)	

//-------------------------------------------------------------------------
//							 
//-------------------------------------------------------------------------

#include <avr/interrupt.h>
#include <util/delay.h>

//-------------------------------------------------------------------------
//							 
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//	  1ware.
//	 1     ,  0
//
//-------------------------------------------------------------------------

BYTE owire_init()					
{
	BYTE SREG_SAVE = SREG;
	cli();									
	BYTE i, j;						
	OWIRE_0;								
	_delay_us(480);							
	OWIRE_1;								
	_delay_us(2);							
	
	for (i=0; i<100; i++)					
	{
		if (!(PIN & (1<<PIN_W)))			
		{
			for(j=1;j!=0;j++) // ,   -    255 
				{
					if(PIN & (1<<PIN_W)) break; // ,  .
					_delay_us(1);
				}
			SREG = SREG_SAVE;
			sei();							
			if(j)return 1; // 
				else return 0;	//      ,     .
		}
		_delay_us(1);						
	}
	SREG = SREG_SAVE;
	sei();									
	return 0;								
}

//-------------------------------------------------------------------------
//	     1ware.
//
//	 :
//
//		BYTE b -      
//-------------------------------------------------------------------------

void owire_write(BYTE b)			
{
	cli();									
	BYTE temp, i;					
	for(i=0; i<8; i++)						
	{
		temp=(b&0x01);						
		if(temp)							
		{
			OWIRE_0;						
			_delay_us(6);					
			OWIRE_1;					
			_delay_us(64);					
		}
		else								
		{
			OWIRE_0;						
			_delay_us(60);					
			OWIRE_1;						
			_delay_us(10);					
		}
		b>>=1;								
	}
	sei();									
}

//-------------------------------------------------------------------------
//	    .
//	   
//
//-------------------------------------------------------------------------

BYTE owire_read_bit()				
{
	cli();									
	BYTE bit;						
	OWIRE_0;								
	_delay_us(2);							
	OWIRE_1;								
	_delay_us(5);							
	bit = PIN & (1<<PIN_W);					
	_delay_us(80);							
	sei();									
	return bit;								
}

//-------------------------------------------------------------------------
//	    .
//	  
//
//-------------------------------------------------------------------------

BYTE owire_read()					
{
	cli();									
	BYTE byte = 0, i;					
	for (i=0; i<8; i++)						
	{
		byte >>= 1;							
		if (owire_read_bit())				
		byte |= 0x80;						
	}
	sei();									
	return byte;							
}



#endif /* W_H_ */