
//-----------------------------------------------<                     axlib v1.1                      >----------------------------------------------------
//-----------------------------------------------<       DS1820 >----------------------------------------------------
//-----------------------------------------------<        2015 http://www.avrki.ru      >----------------------------------------------------

#ifndef DS1820_H_
#define DS1820_H_

#if !defined(W_H_)
#error "You must included (#include <axlib/1w.h>) befor use (#include \"axlib/ds1820.h\")."
#endif

//-------------------------------------------------------------------------
//						  
//-------------------------------------------------------------------------

#define PLUS		0
#define MINUS		1
#define RESOL_9		0x1F
#define RESOL_10	0x3F
#define RESOL_11	0x5F
#define RESOL_12	0x7F

//-------------------------------------------------------------------------
//						 
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//						  
//-------------------------------------------------------------------------

volatile BYTE ZNAK = PLUS; 

//-------------------------------------------------------------------------
//							 
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//	  ROM   .
//	       .
//  ROM     .   8 .
//
//    0     , 1   .
//
//	 :
//
//		BYTE *str -     
//-------------------------------------------------------------------------

BYTE ds1820_rom_code(BYTE *str)
{
	BYTE i = 0;
	BYTE exist= owire_init();
	owire_write(0x33);
	
	while(i < 8)
	{
		*str = owire_read();
		str++;
		i++;
	}
	return exist;
}

//-------------------------------------------------------------------------
//	   .
//	       .
//
//  :	RESOL_9
//							RESOL_10
//							RESOL_11
//							RESOL_12
//
//-------------------------------------------------------------------------
void ds18b20_resol(BYTE resol)
{
	owire_init();
	owire_write(0xCC);
	owire_write(0x4E);	
	owire_write(0x7D);
	owire_write(0xC9);
	owire_write(resol);
	
	_delay_ms(10);
	
	owire_init();
	owire_write(0xCC);
	owire_write(0x48);
}
//-------------------------------------------------------------------------
//	    .
//	       .
//
//-------------------------------------------------------------------------

WORD ds1820_all(void)
{
	BYTE temp[2];
	WORD temper = 0x00;
	BYTE exist = owire_init();
	owire_write(0xCC);
	owire_write(0x44);
	
	_delay_ms(10);

	owire_init();
	owire_write(0xCC);
	owire_write(0xBE);
	
	temp[0] = owire_read();
	temp[1] = owire_read();
	
	if(temp[1] & 0x80)
		{
			temp[0] = (~temp[0])+1;
			temp[1] = ~temp[1];
			ZNAK = MINUS;
		}
	else
		{
			ZNAK = PLUS;
		}
	
	owire_init();
	
	temper = (((WORD)temp[1] << 8) | (WORD)(temp[0] * 5));
	if(exist) return 	temper;
	else return 0x8000;
}

//-------------------------------------------------------------------------
//	       ROM .
//	       .
//
//   
//
//		BYTE *rom -   8-    ROM 
//
//-------------------------------------------------------------------------

WORD ds1820_read_t(BYTE *rom)
{
	BYTE i = 0;
	BYTE temp[2];
	WORD temper = 0x00;
	BYTE rm = 0;
	
	BYTE exist = owire_init();
	owire_write(0xCC);
	owire_write(0x44);
	
	_delay_ms(10);

	i = 0;
	
	owire_init();
	owire_write(0x55);
	
	rm = *rom;
	
	while(i < 8)
		{
			owire_write(*rom);
			rom++;
			i++;
		}
	owire_write(0xBE);

	temp[0] = owire_read();
	temp[1] = owire_read();
	
	if(temp[1] & 0x80)
		{
			temp[0] = ~temp[0] + 1;
			temp[1] = ~temp[1];
			ZNAK = MINUS;
		}
	else
		{
			ZNAK = PLUS;
		}
	
	if(rm == 0x10)
		{
			temper = (temp[1] << 8) | (temp[0] * 5);
		}
	else
		{
			temper = ((temp[1] << 5) | (temp[0] >> 3)) * 5;
			//temper = temp[0];
		}
	
	owire_init();
	
if(exist) return 	temper;
	else return 0x8000;
}



signed short ds1820_all_m(void)
{
	BYTE temp[2];
	WORD temper = 0x00;
	BYTE exist = owire_init();
	owire_write(0xCC);
	owire_write(0x44);
	
	_delay_ms(750);

	owire_init();
	owire_write(0xCC);
	owire_write(0xBE);
	
	temp[0] = owire_read();
	temp[1] = owire_read();
	
	
	owire_init();
	
	
	
*((unsigned char*)&temper)= temp[0];
*((unsigned char*)&temper+1)= temp[1];
//temper *=10;
temper/=16;	
	
return temper;	//    16
}


#endif /* DS1820_H_ */