//#######################################################################################################################
//
//     
//
//     BtnInit();
//       100 -  BtnExe();
//          BtnGet();
//
//#######################################################################################################################
#include "main_init.h"
//   
#define BTN_LOCK_TIME		50	/*     (10-100)*/
#define BTN_LONG_TIME		1000				/*      (1000 - 2500)*/
#define BTN_L_LONG_TIME		2500				/*       (> 2500)*/

// 
#define BTN_PORT			PORTD				/*  */
#define BTN_DDR				DDRD
#define BTN_PIN				PIND                    
#define BTN_LINE_PLUS		(1<<5)				/*  */
#define BTN_LINE_MINUS   	(1<<6)
#define BTN_LINE_OK	        (1<<7)
	
#define PERIOD_BUTT_TICK    10      //     
    
//#######################################################################################################################
//
//    
//
//#######################################################################################################################

// 
volatile uint8_t BtnFlags;//   
	#define BTN_SHRT_PLUS		(1<<0) 			/*    plus*/ 
	#define BTN_SHRT_MINUS		(1<<1) 		    /*    minus*/ 
	#define BTN_SHRT_OK		    (1<<2)  		/*    ok*/ 
	#define BTN_LONG_PLUS		(1<<3) 			/*    plus*/ 
	#define BTN_LONG_MINUS		(1<<4) 			/*    minus*/ 
	#define BTN_LONG_OK		    (1<<5) 			/*    ok*/ 
	#define BTN_L_LONG_PLUS		(1<<6) 			/*     plus*/ 
    #define BTN_L_LONG_MINUS	(1<<7) 			/*     minus*/ 
    
//-----------------------------------------------------------------------------------------------------------------------
//     
void BtnInit (void)
{    
	BTN_DDR &= ~(BTN_LINE_PLUS| BTN_LINE_MINUS| BTN_LINE_OK);// 
	BTN_PORT |= (BTN_LINE_PLUS| BTN_LINE_MINUS| BTN_LINE_OK);// 
}

//-----------------------------------------------------------------------------------------------------------------------
//     
char BtnGet (void)
{
	uint8_t temp;
	cli ();
	temp = BtnFlags;
	BtnFlags = 0;
	sei ();
	return temp;
}

//-----------------------------------------------------------------------------------------------------------------------
//    (     100 )
//    BTN_SHRT_X   BtnFlags
//    BTN_LONG_X   BtnFlags
void BtnExe (void)
{    
	static uint8_t BtnLockBit;			// (  )
	static uint8_t BtnLockCoun;			//  (  )
	static uint8_t BtnLongCoun;			//   
	static uint8_t BtnLastState;		//    

	char mask = 0;
	if (! (BTN_PIN & BTN_LINE_PLUS))		mask = BTN_SHRT_PLUS;
	if (! (BTN_PIN & BTN_LINE_MINUS))		mask = BTN_SHRT_MINUS;
	if (! (BTN_PIN & BTN_LINE_OK))	        mask = BTN_SHRT_OK;
	

	if (mask){									//  
		if (BtnLockCoun < (BTN_LOCK_TIME/PERIOD_BUTT_TICK)){	// 
			BtnLockCoun++;
			return;								//    - 
		}
		BtnLastState = mask;
		BtnLockBit =1;							//  

		
		if (BtnLongCoun >= (BTN_L_LONG_TIME/PERIOD_BUTT_TICK)){                                
			return;								//, ..         
		}	
		if (++BtnLongCoun >= (BTN_L_LONG_TIME/PERIOD_BUTT_TICK)){
		BtnFlags |= (BtnLastState<<6);			//    -       
		}
	}            
	else{										//             
		if (BtnLockCoun){
			BtnLockCoun --;
			return;								//    - 
		}
		if (! BtnLockBit){						// 
			return;
		}	
		
		BtnLockBit =0;							// 
		
		
		if ((BtnLongCoun < (BTN_L_LONG_TIME/PERIOD_BUTT_TICK))&(BtnLongCoun >=(BTN_LONG_TIME/PERIOD_BUTT_TICK))){
			BtnFlags |= (BtnLastState<<3);			//   
			}
		
		if (BtnLongCoun < (BTN_LONG_TIME/PERIOD_BUTT_TICK)){
			BtnFlags |= BtnLastState;			//   
		}
			BtnLongCoun = 0;					//   
			BtnLastState =0;
		}
}    
	
//#######################################################################################################################
//
//  THE END
//
//#######################################################################################################################
